---
title: RTCPeerConnection.removeTrack()
slug: Web/API/RTCPeerConnection/removeTrack
tags:
  - Audio
  - Media
  - Method
  - RTCPeerConnection
  - Reference
  - Tracks
  - Video
  - WebRTC
  - removeTrack
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <code><strong>RTCPeerConnection.removeTrack()</strong></code> method tells the local end of the connection to stop sending media from the specified track, without actually removing the corresponding {{domxref("RTCRtpSender")}} from the list of senders as reported by {{domxref("RTCPeerConnection.getSenders()")}}.</span> If the track is already stopped, or is not in the connection's senders list, this method has no effect.</p>

<p>If the connection has already been negotiated ({{domxref("RTCPeerConnection.signalingState", "signalingState")}} is set to <code>"stable"</code>), it is marked as needing to be negotiated again; the remote peer won't experience the change until this negotiation occurs. A {{event("negotiationneeded")}} event is sent to the {{domxref("RTCPeerConnection")}} to let the local end know this negotiation must occur.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><code><em>pc</em>.removeTrack(sender);
</code></pre>

<h3 id="Example">Parameters</h3>

<dl>
 <dt><code>mediaTrack</code></dt>
 <dd>A {{domxref("RTCRtpSender")}} specifying the sender to remove from the connection.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>The connection is not open.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example adds a video track to a connection and sets up a listener on a close button which removes the track when the user clicks the button.</p>

<pre class="brush: js">var pc, sender;
navigator.getUserMedia({video: true}, function(stream) {
  pc = new RTCPeerConnection();
  var track = stream.getVideoTracks()[0];
  sender = pc.addTrack(track, stream);
});

document.getElementById("closeButton").addEventListener("click", function(event) {
  pc.removeTrack(sender);
  pc.close();
}, false);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table" style="height: 49px; width: 1000px;">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-rtcpeerconnection-removetrack', 'RTCPeerConnection.removeTrack()') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.removeTrack")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
</ul>
